/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 *
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 */
(function () {
  var pluginName = 'restore';
  CKEDITOR.plugins.add(pluginName, {
    init: function init(editor) {
      editor.addCommand(pluginName, {
        canUndo: false,
        exec: function exec(editor) {
          editor.fire('restoreContent');
        }
      });

      if (editor.ui.addButton) {
        editor.ui.addButton('Restore', {
          command: pluginName,
          icon: Liferay.AUI.getPathCKEditor() + '/ckeditor/plugins/restore/assets/restore.png',
          label: Liferay.Language.get('restore-the-original-content')
        });
      }
    }
  });
})();
//# sourceMappingURL=plugin.js.map